<template lang="pug">
  span
    a.chip.c-hand(v-if="!text" :href="actor.profileUrl")
      img.avatar.avatar-sm(v-if="icon && !noAvatar" :src="icon" @error="() => icon = undefined")
      span {{ isLocal ? actor.name : actor.fullUsername }}
    span.chip.c-hand(v-else) {{ text }}
</template>

<script>
import environment from '~/mixins/environment'

export default {
  mixins: [environment],
  props: {
    actor: {
      type: Object,
      default: () => {}
    },
    text: {
      type: String,
      default: ''
    },
    noAvatar: Boolean
  },
  data() {
    return {
      icon: this.actor && this.actor.icon && this.parseIcon(this.actor.icon)
    }
  },
  computed: {
    isLocal() {
      return (
        this.actor.fullUsername.split('@')[1] ===
        this.extractHostname(this.baseURL)
      )
    }
  },
  methods: {
    parseIcon: icon => (typeof icon === 'string' ? icon : icon.url),
    extractHostname: url => {
      let hostname
      // find & remove protocol (http, ftp, etc.) and get hostname

      if (url.includes('//')) hostname = url.split('/')[2]
      else hostname = url.split('/')[0]

      // find & remove "?"
      hostname = hostname.split('?')[0]

      return hostname
    }
  }
}
</script>

<style scoped>
a:active {
  text-decoration: none !important;
}
</style>
